#!/usr/bin/python

import os
import vot
import sys
import time
import cv2 as cv
import numpy as np
import collections

# from pytracking.tracker.trSeg import TrSeg as Treg
# import pytracking.parameter.trSeg.fcotv3_vot2019 as vot_params
from pytracking.tracker.trSeg import TrSeg as Treg
import pytracking.parameter.trSeg.trSeg as vot_params
class TREGTracker(object):

    def __init__(self, tracker):
        self.tracker = tracker
        # self.tracker.initialize(image, info)

    def track(self, image):

        # left = max(round(self.position[0] - float(self.window) / 2), 0)
        # top = max(round(self.position[1] - float(self.window) / 2), 0)

        # right = min(round(self.position[0] + float(self.window) / 2), image.shape[1] - 1)
        # bottom = min(round(self.position[1] + float(self.window) / 2), image.shape[0] - 1)

        # if right - left < self.template.shape[1] or bottom - top < self.template.shape[0]:
        #     return vot.Rectangle(self.position[0] + self.size[0] / 2, self.position[1] + self.size[1] / 2, self.size[0], self.size[1])

        # cut = image[int(top):int(bottom), int(left):int(right)]

        # matches = cv2.matchTemplate(cut, self.template, cv2.TM_CCOEFF_NORMED)
        # min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(matches)

        # self.position = (left + max_loc[0] + float(self.size[0]) / 2, top + max_loc[1] + float(self.size[1]) / 2)
        output = self.tracker.track(image)
        mask = output['mask']

        return mask, 1


def make_full_size(x, output_sz):
    '''
    zero-pad input x (right and down) to match output_sz
    x: numpy array e.g., binary mask
    output_sz: size of the output [width, height]
    '''
    if x.shape[0] == output_sz[1] and x.shape[1] == output_sz[0]:
        return x
    pad_x = output_sz[0] - x.shape[1]
    if pad_x < 0:
        x = x[:, :x.shape[1] + pad_x]
        # padding has to be set to zero, otherwise pad function fails
        pad_x = 0
    pad_y = output_sz[1] - x.shape[0]
    if pad_y < 0:
        x = x[:x.shape[0] + pad_y, :]
        # padding has to be set to zero, otherwise pad function fails
        pad_y = 0
    return np.pad(x, ((0, pad_y), (0, pad_x)), 'constant', constant_values=0)


handle = vot.VOT("mask")
# handle.get_request()


params = vot_params.parameters()
treg = Treg(params)
tracker = TREGTracker(treg)
selection = handle.region()
imagefile = handle.frame()

image = cv.cvtColor(cv.imread(imagefile), cv.COLOR_BGR2RGB)
mask = make_full_size(selection, (image.shape[1], image.shape[0]))
init_info = {'init_mask': mask}
tracker.tracker.initialize(image, init_info)

while True:
    imagefile = handle.frame()

    if not imagefile:
        break

    image = cv.cvtColor(cv.imread(imagefile), cv.COLOR_BGR2RGB)
    region, confidence = tracker.track(image)
    handle.report(region, confidence)

